#pragma once
#if defined VERTEX_SHADER
#include <required2.glsl>

#ifndef sc_StereoRendering_InstancedClipped
#define sc_StereoRendering_InstancedClipped 0
#endif
#ifndef sc_StereoscopicMatrixIndex
#define sc_StereoscopicMatrixIndex 0
#endif
#ifndef SC_DEVICE_CLASS
#define SC_DEVICE_CLASS -1
#endif
#ifndef sc_RenderingSpace
#define sc_RenderingSpace -1
#endif
#ifndef SC_GL_FRAGMENT_PRECISION_HIGH
#define SC_GL_FRAGMENT_PRECISION_HIGH 0
#endif
#ifndef ENABLE_STIPPLE_PATTERN_TEST
#define ENABLE_STIPPLE_PATTERN_TEST 0
#endif
#ifndef sc_IsEditor
#define sc_IsEditor 0
#endif
#ifndef sc_FramebufferFetch
#define sc_FramebufferFetch 0
#endif
#ifndef sc_GetFramebufferColorInvalidUsageMarker
#define sc_GetFramebufferColorInvalidUsageMarker 0
#endif
#ifndef sc_PointLightsCount
#define sc_PointLightsCount 4
#endif
#ifndef sc_DirectionalLightsCount
#define sc_DirectionalLightsCount 4
#endif
#ifndef sc_AmbientLightsCount
#define sc_AmbientLightsCount 4
#endif
#ifndef sc_AmbientLightMode0
#define sc_AmbientLightMode0 0
#endif
#ifndef sc_AmbientLightMode1
#define sc_AmbientLightMode1 0
#endif
#ifndef sc_AmbientLightMode2
#define sc_AmbientLightMode2 0
#endif
#ifndef sc_AmbientLightMode_Constant
#define sc_AmbientLightMode_Constant 0
#endif
#ifndef sc_AmbientLightMode_SphericalHarmonics
#define sc_AmbientLightMode_SphericalHarmonics 0
#endif
#ifndef sc_AmbientLightMode_EnvironmentMap
#define sc_AmbientLightMode_EnvironmentMap 0
#endif
#ifndef sc_EnvLightMode
#define sc_EnvLightMode 0
#endif
#ifndef sc_ProjectiveShadowsCaster
#define sc_ProjectiveShadowsCaster 0
#endif
#ifndef sc_ProjectiveShadowsReceiver
#define sc_ProjectiveShadowsReceiver 0
#endif
#ifndef sc_StereoRendering_Multiview
#define sc_StereoRendering_Multiview 0
#endif
#ifndef sc_StereoClipPlaneCount
#define sc_StereoClipPlaneCount 0
#endif
#ifndef sc_StereoscopicEyeCount
#define sc_StereoscopicEyeCount 0
#endif
#ifndef sc_MaxTextureImageUnits
#define sc_MaxTextureImageUnits 0
#endif
#ifndef sc_HasDiffuseEnvmap
#define sc_HasDiffuseEnvmap 0
#endif
#ifndef sc_ShaderComplexityAnalyzer
#define sc_ShaderComplexityAnalyzer 0
#endif
#ifndef sc_BlendMode_Disabled
#define sc_BlendMode_Disabled 0
#endif
#ifndef sc_BlendMode_Normal
#define sc_BlendMode_Normal 0
#endif
#ifndef sc_BlendMode_Multiply
#define sc_BlendMode_Multiply 0
#endif
#ifndef sc_BlendMode_Add
#define sc_BlendMode_Add 0
#endif
#ifndef sc_BlendMode_Screen
#define sc_BlendMode_Screen 0
#endif
#ifndef sc_BlendMode_PremultipliedAlpha
#define sc_BlendMode_PremultipliedAlpha 0
#endif
#ifndef sc_BlendMode_AlphaToCoverage
#define sc_BlendMode_AlphaToCoverage 0
#endif
#ifndef sc_BlendMode_MultiplyOriginal
#define sc_BlendMode_MultiplyOriginal 0
#endif
#ifndef sc_BlendMode_AddWithAlphaFactor
#define sc_BlendMode_AddWithAlphaFactor 0
#endif
#ifndef sc_BlendMode_Min
#define sc_BlendMode_Min 0
#endif
#ifndef sc_BlendMode_Max
#define sc_BlendMode_Max 0
#endif
#ifndef sc_BlendMode_AlphaTest
#define sc_BlendMode_AlphaTest 0
#endif
#ifndef sc_BlendMode_ColoredGlass
#define sc_BlendMode_ColoredGlass 0
#endif
#ifndef sc_BlendMode_PremultipliedAlphaHardware
#define sc_BlendMode_PremultipliedAlphaHardware 0
#endif
#ifndef sc_BlendMode_Custom
#define sc_BlendMode_Custom 0
#endif
#ifndef sc_BlendMode_Software
#define sc_BlendMode_Software 0
#endif
#ifndef sc_BlendMode_Hardware
#define sc_BlendMode_Hardware 0
#endif

struct sc_Camera_t
{
    vec3 position;
    float aspect;
    vec2 clipPlanes;
};

struct sc_PointLight_t
{
    vec3 position;
    vec4 color;
};

struct sc_DirectionalLight_t
{
    vec3 direction;
    vec4 color;
};

struct sc_AmbientLight_t
{
    vec3 color;
    float intensity;
    #ifndef SC_REMOVE_ENVMAP_FROM_AMBIENT_LIGHT_STRUCT
    float weight;
    vec3 sphericalHarmonics[9];
    vec3 rotation;
    float exposure;
    mediump sampler2D diffuseEnvMap;
    mediump sampler2D specularEnvMap;
    #endif
};

uniform vec4 sc_ScreenTextureSize;
uniform mediump sampler2D sc_EnvmapDiffuse;
uniform vec4 sc_EnvmapDiffuseSize;
uniform mediump sampler2D sc_EnvmapSpecular;
uniform vec4 sc_EnvmapSpecularSize;
uniform vec3 sc_EnvmapRotation;
uniform float sc_EnvmapExposure;
uniform vec3 sc_Sh[9];
uniform float sc_ShIntensity;
uniform vec4 sc_Time;
uniform vec4 sc_GeometryInfo;
uniform mat4 sc_ModelViewProjectionMatrix;
uniform mat4 sc_ModelViewProjectionMatrixInverse;
uniform mat4 sc_ViewProjectionMatrix;
uniform mat4 sc_ViewProjectionMatrixInverse;
uniform mat4 sc_ModelViewMatrix;
uniform mat4 sc_ModelViewMatrixInverse;
uniform mat3 sc_ViewNormalMatrix;
uniform mat3 sc_ViewNormalMatrixInverse;
uniform mat4 sc_ProjectionMatrix;
uniform mat4 sc_ProjectionMatrixInverse;
uniform mat4 sc_ViewMatrix;
uniform mat4 sc_ViewMatrixInverse;
uniform mat4 sc_ModelMatrix;
uniform mat4 sc_ModelMatrixInverse;
uniform mat3 sc_NormalMatrix;
uniform mat3 sc_NormalMatrixInverse;
uniform mediump sampler2D sc_ScreenTexture;
uniform sc_Camera_t sc_Camera;
uniform sc_PointLight_t sc_PointLights[sc_PointLightsCount];
uniform sc_DirectionalLight_t sc_DirectionalLights[sc_DirectionalLightsCount];
uniform sc_AmbientLight_t sc_AmbientLights[sc_AmbientLightsCount];

vec2 sc_StereoClampTextureCoords(inout vec2 uv)
{
    #if (sc_StereoRendering_InstancedClipped)
    {
        float pixelHeight = sc_ScreenTextureSize.w;
        float _41;
        #if (sc_StereoscopicMatrixIndex == 0)
        {
            _41 = max(uv.y, 0.5 + pixelHeight);
        }
        #else // #if (sc_StereoscopicMatrixIndex == 0)
        {
            _41 = min(uv.y, 0.5 - pixelHeight);
        }
        #endif // #else // #if (sc_StereoscopicMatrixIndex == 0)
        uv.y = _41;
    }
    #endif // #if (sc_StereoRendering_InstancedClipped)
    return uv;
}

vec4 sc_SampleScreenTexture(vec2 uv)
{
    // Notice, the extra definition is needed for GLShaderSourceBuilder to avoid recursion,
    // as it substitutes "texture2D(sc_ScreenTexture," with "sc_SampleScreenTexture(".
    #define stereoScreenTexture sc_ScreenTexture
    return texture2D(stereoScreenTexture, sc_StereoClampTextureCoords(uv));
    #undef stereoScreenTexture

}

vec2 sc_StereoClampMapTextureCoords(inout vec2 uv)
{
    #if (sc_StereoRendering_InstancedClipped)
    {
        float stereoMatrixId = float(sc_StereoscopicMatrixIndex);
        uv.y = (uv.y * 0.5) + (0.5 - (stereoMatrixId * 0.5));
    }
    #endif // #if (sc_StereoRendering_InstancedClipped)
    vec2 param = uv;
    vec2 _77 = sc_StereoClampTextureCoords(param);
    return _77;
}

vec4 sc_SampleMapScreenTexture(vec2 uv)
{
    // Notice, the extra definition is needed for GLShaderSourceBuilder to avoid recursion,
    // as it substitutes "texture2D(sc_ScreenTexture," with "sc_SampleMapScreenTexture(".
    #define stereoScreenTexture sc_ScreenTexture
    return texture2D(stereoScreenTexture, sc_StereoClampMapTextureCoords(uv));
    #undef stereoScreenTexture

}

#elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
#include <required2.glsl>
precision mediump float;
precision highp int;

#ifndef sc_StereoRendering_InstancedClipped
#define sc_StereoRendering_InstancedClipped 0
#endif
#ifndef sc_StereoscopicMatrixIndex
#define sc_StereoscopicMatrixIndex 0
#endif
#ifndef SC_DEVICE_CLASS
#define SC_DEVICE_CLASS -1
#endif
#ifndef sc_RenderingSpace
#define sc_RenderingSpace -1
#endif
#ifndef SC_GL_FRAGMENT_PRECISION_HIGH
#define SC_GL_FRAGMENT_PRECISION_HIGH 0
#endif
#ifndef ENABLE_STIPPLE_PATTERN_TEST
#define ENABLE_STIPPLE_PATTERN_TEST 0
#endif
#ifndef sc_IsEditor
#define sc_IsEditor 0
#endif
#ifndef sc_FramebufferFetch
#define sc_FramebufferFetch 0
#endif
#ifndef sc_GetFramebufferColorInvalidUsageMarker
#define sc_GetFramebufferColorInvalidUsageMarker 0
#endif
#ifndef sc_PointLightsCount
#define sc_PointLightsCount 4
#endif
#ifndef sc_DirectionalLightsCount
#define sc_DirectionalLightsCount 4
#endif
#ifndef sc_AmbientLightsCount
#define sc_AmbientLightsCount 4
#endif
#ifndef sc_AmbientLightMode0
#define sc_AmbientLightMode0 0
#endif
#ifndef sc_AmbientLightMode1
#define sc_AmbientLightMode1 0
#endif
#ifndef sc_AmbientLightMode2
#define sc_AmbientLightMode2 0
#endif
#ifndef sc_AmbientLightMode_Constant
#define sc_AmbientLightMode_Constant 0
#endif
#ifndef sc_AmbientLightMode_SphericalHarmonics
#define sc_AmbientLightMode_SphericalHarmonics 0
#endif
#ifndef sc_AmbientLightMode_EnvironmentMap
#define sc_AmbientLightMode_EnvironmentMap 0
#endif
#ifndef sc_EnvLightMode
#define sc_EnvLightMode 0
#endif
#ifndef sc_ProjectiveShadowsCaster
#define sc_ProjectiveShadowsCaster 0
#endif
#ifndef sc_ProjectiveShadowsReceiver
#define sc_ProjectiveShadowsReceiver 0
#endif
#ifndef sc_StereoRendering_Multiview
#define sc_StereoRendering_Multiview 0
#endif
#ifndef sc_StereoClipPlaneCount
#define sc_StereoClipPlaneCount 0
#endif
#ifndef sc_StereoscopicEyeCount
#define sc_StereoscopicEyeCount 0
#endif
#ifndef sc_MaxTextureImageUnits
#define sc_MaxTextureImageUnits 0
#endif
#ifndef sc_HasDiffuseEnvmap
#define sc_HasDiffuseEnvmap 0
#endif
#ifndef sc_ShaderComplexityAnalyzer
#define sc_ShaderComplexityAnalyzer 0
#endif
#ifndef sc_BlendMode_Disabled
#define sc_BlendMode_Disabled 0
#endif
#ifndef sc_BlendMode_Normal
#define sc_BlendMode_Normal 0
#endif
#ifndef sc_BlendMode_Multiply
#define sc_BlendMode_Multiply 0
#endif
#ifndef sc_BlendMode_Add
#define sc_BlendMode_Add 0
#endif
#ifndef sc_BlendMode_Screen
#define sc_BlendMode_Screen 0
#endif
#ifndef sc_BlendMode_PremultipliedAlpha
#define sc_BlendMode_PremultipliedAlpha 0
#endif
#ifndef sc_BlendMode_AlphaToCoverage
#define sc_BlendMode_AlphaToCoverage 0
#endif
#ifndef sc_BlendMode_MultiplyOriginal
#define sc_BlendMode_MultiplyOriginal 0
#endif
#ifndef sc_BlendMode_AddWithAlphaFactor
#define sc_BlendMode_AddWithAlphaFactor 0
#endif
#ifndef sc_BlendMode_Min
#define sc_BlendMode_Min 0
#endif
#ifndef sc_BlendMode_Max
#define sc_BlendMode_Max 0
#endif
#ifndef sc_BlendMode_AlphaTest
#define sc_BlendMode_AlphaTest 0
#endif
#ifndef sc_BlendMode_ColoredGlass
#define sc_BlendMode_ColoredGlass 0
#endif
#ifndef sc_BlendMode_PremultipliedAlphaHardware
#define sc_BlendMode_PremultipliedAlphaHardware 0
#endif
#ifndef sc_BlendMode_Custom
#define sc_BlendMode_Custom 0
#endif
#ifndef sc_BlendMode_Software
#define sc_BlendMode_Software 0
#endif
#ifndef sc_BlendMode_Hardware
#define sc_BlendMode_Hardware 0
#endif

struct sc_Camera_t
{
    highp vec3 position;
    highp float aspect;
    highp vec2 clipPlanes;
};

struct sc_PointLight_t
{
    highp vec3 position;
    highp vec4 color;
};

struct sc_DirectionalLight_t
{
    highp vec3 direction;
    highp vec4 color;
};

struct sc_AmbientLight_t
{
    highp vec3 color;
    highp float intensity;
    #ifndef SC_REMOVE_ENVMAP_FROM_AMBIENT_LIGHT_STRUCT
    highp float weight;
    highp vec3 sphericalHarmonics[9];
    highp vec3 rotation;
    highp float exposure;
    mediump sampler2D diffuseEnvMap;
    mediump sampler2D specularEnvMap;
    #endif
};

uniform highp vec4 sc_ScreenTextureSize;
uniform mediump sampler2D sc_EnvmapDiffuse;
uniform highp vec4 sc_EnvmapDiffuseSize;
uniform mediump sampler2D sc_EnvmapSpecular;
uniform highp vec4 sc_EnvmapSpecularSize;
uniform highp vec3 sc_EnvmapRotation;
uniform highp float sc_EnvmapExposure;
uniform highp vec3 sc_Sh[9];
uniform highp float sc_ShIntensity;
uniform highp vec4 sc_Time;
uniform highp vec4 sc_GeometryInfo;
uniform highp mat4 sc_ModelViewProjectionMatrix;
uniform highp mat4 sc_ModelViewProjectionMatrixInverse;
uniform highp mat4 sc_ViewProjectionMatrix;
uniform highp mat4 sc_ViewProjectionMatrixInverse;
uniform highp mat4 sc_ModelViewMatrix;
uniform highp mat4 sc_ModelViewMatrixInverse;
uniform highp mat3 sc_ViewNormalMatrix;
uniform highp mat3 sc_ViewNormalMatrixInverse;
uniform highp mat4 sc_ProjectionMatrix;
uniform highp mat4 sc_ProjectionMatrixInverse;
uniform highp mat4 sc_ViewMatrix;
uniform highp mat4 sc_ViewMatrixInverse;
uniform highp mat4 sc_ModelMatrix;
uniform highp mat4 sc_ModelMatrixInverse;
uniform highp mat3 sc_NormalMatrix;
uniform highp mat3 sc_NormalMatrixInverse;
uniform mediump sampler2D sc_ScreenTexture;
uniform sc_Camera_t sc_Camera;
uniform sc_PointLight_t sc_PointLights[sc_PointLightsCount];
uniform sc_DirectionalLight_t sc_DirectionalLights[sc_DirectionalLightsCount];
uniform sc_AmbientLight_t sc_AmbientLights[sc_AmbientLightsCount];


highp vec2 sc_StereoClampTextureCoords(inout highp vec2 uv)
{
    #if (sc_StereoRendering_InstancedClipped)
    {
        highp float pixelHeight = sc_ScreenTextureSize.w;
        highp float _127;
        #if (sc_StereoscopicMatrixIndex == 0)
        {
            _127 = max(uv.y, 0.5 + pixelHeight);
        }
        #else // #if (sc_StereoscopicMatrixIndex == 0)
        {
            _127 = min(uv.y, 0.5 - pixelHeight);
        }
        #endif // #else // #if (sc_StereoscopicMatrixIndex == 0)
        uv.y = _127;
    }
    #endif // #if (sc_StereoRendering_InstancedClipped)
    return uv;
}

highp vec4 sc_SampleScreenTexture(highp vec2 uv)
{
    // Notice, the extra definition is needed for GLShaderSourceBuilder to avoid recursion,
    // as it substitutes "texture2D(sc_ScreenTexture," with "sc_SampleScreenTexture(".
    #define stereoScreenTexture sc_ScreenTexture
    return texture2D(stereoScreenTexture, sc_StereoClampTextureCoords(uv));
    #undef stereoScreenTexture

}

highp vec2 sc_StereoClampMapTextureCoords(inout highp vec2 uv)
{
    #if (sc_StereoRendering_InstancedClipped)
    {
        highp float stereoMatrixId = float(sc_StereoscopicMatrixIndex);
        uv.y = (uv.y * 0.5) + (0.5 - (stereoMatrixId * 0.5));
    }
    #endif // #if (sc_StereoRendering_InstancedClipped)
    highp vec2 param = uv;
    highp vec2 _163 = sc_StereoClampTextureCoords(param);
    return _163;
}

highp vec4 sc_SampleMapScreenTexture(highp vec2 uv)
{
    // Notice, the extra definition is needed for GLShaderSourceBuilder to avoid recursion,
    // as it substitutes "texture2D(sc_ScreenTexture," with "sc_SampleMapScreenTexture(".
    #define stereoScreenTexture sc_ScreenTexture
    return texture2D(stereoScreenTexture, sc_StereoClampMapTextureCoords(uv));
    #undef stereoScreenTexture

}

#endif // #elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
