#pragma once
#if defined VERTEX_SHADER
#include <std2.glsl>



#elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
#include <std2.glsl>
precision mediump float;
precision highp int;

uniform highp float _sc_GetFramebufferColorInvalidUsageMarker;
uniform highp float shaderComplexityValue;


highp vec2 getScreenUV()
{
    return gl_FragCoord.xy * sc_ScreenTextureSize.zw;
}

highp vec4 getFramebufferColor()
{
    highp vec4 result = vec4(0.0);
    #if (!(sc_FramebufferFetch == 1))
    {
        result = texture2D(sc_ScreenTexture, getScreenUV());
    }
    #else // #if (!(sc_FramebufferFetch == 1))
    {
        result = sc_readFragData0();
    }
    #endif // #else // #if (!(sc_FramebufferFetch == 1))
    #if ((((sc_IsEditor == 1) && (sc_GetFramebufferColorInvalidUsageMarker == 1)) && (!(sc_BlendMode_Software == 1))) && (!(sc_BlendMode_ColoredGlass == 1)))
    {
        result.x += _sc_GetFramebufferColorInvalidUsageMarker;
    }
    #endif // #if ((((sc_IsEditor == 1) && (sc_GetFramebufferColorInvalidUsageMarker == 1)) && (!(sc_BlendMode_Software == 1))) && (!(sc_BlendMode_ColoredGlass == 1)))
    return result;
}

highp vec4 getPixelRenderingCost()
{
    #if (sc_ShaderComplexityAnalyzer)
    {
        return vec4(shaderComplexityValue / 255.0, 0.0, 0.0, 1.0);
    }
    #else // #if (sc_ShaderComplexityAnalyzer)
    {
        return vec4(0.0);
    }
    #endif // #else // #if (sc_ShaderComplexityAnalyzer)
}

#endif // #elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
