#pragma once
#if defined VERTEX_SHADER
#include <required2.glsl>

#elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
#include <required2.glsl>
precision mediump float;
precision highp int;



highp vec4 sc_texture2DLodGL(mediump sampler2D tex, highp vec2 _textureSize, highp vec2 uv, highp float lod)
{
#if (__VERSION__ == 120)
#define SC_TESTURE2DLOD_IS_SUPPORTED
    return texture2DLod(tex, uv, lod);
#elif (__VERSION__ >= 300)
#define SC_TESTURE2DLOD_IS_SUPPORTED
    return textureLod(tex, uv, lod);
#elif defined(GL_EXT_shader_texture_lod)
#define SC_TESTURE2DLOD_IS_SUPPORTED
    return texture2DLodEXT(tex, uv, lod);
#elif defined(GL_OES_standard_derivatives)
#define SC_TESTURE2DLOD_IS_SUPPORTED
    vec2 texels = uv * _textureSize;
    float dudx = dFdx(texels.x);
    float dvdx = dFdx(texels.y);
    float dudy = dFdy(texels.x);
    float dvdy = dFdy(texels.y);
    float rho = max(length(vec2(dudx, dvdx)), length(vec2(dudy, dvdy))); // OpenGL reference calculation
    float mu = max(abs(dudx), abs(dudy));
    float mv = max(abs(dvdx), abs(dvdy));
    float rho2 = max(mu, mv); // The allowed alternative OpoenGL reference calculation that seems to match the main reference best.
    float mip = log2(rho2);
    float bias = lod - mip;
    return texture2D(tex, uv, bias);
#else
    return texture2D(tex, uv, lod);
#endif

}

highp vec4 sc_texture2DLod(mediump sampler2D tex, highp vec2 _textureSize, highp vec2 uv, highp float lod)
{
    highp vec2 param = _textureSize;
    highp vec2 param_1 = uv;
    highp float param_2 = lod;
    return sc_texture2DLodGL(tex, param, param_1, param_2);
}

#endif // #elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
