#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

constant bool SC_BLEND_MODE_CUSTOM [[function_constant(0)]];
constant bool SC_BLEND_MODE_SCREEN [[function_constant(1)]];
constant int SC_DEVICE_CLASS [[function_constant(2)]];
constant bool SC_GL_FRAGMENT_PRECISION_HIGH [[function_constant(3)]];
constant bool SC_ENABLE_SRGB_EMULATION_IN_SHADER [[function_constant(4)]];
#ifndef sc_AmbientLightsCount
#define sc_AmbientLightsCount 1
#endif

struct sc_AmbientLight_t
{
    float3 color;
    float intensity;
    float weight;
    float3 sphericalHarmonics[9];
    float3 rotation;
    float exposure;
    texture2d<float> diffuseEnvMap;
    texture2d<float> specularEnvMap;
};

struct sc_PointLight_t
{
    float3 position;
    float4 color;
};

struct sc_DirectionalLight_t
{
    float3 direction;
    float4 color;
};

struct LibraryUniforms
{
    sc_AmbientLight_t sc_AmbientLights[sc_AmbientLightsCount];
    float4 sc_Time;
    float4 sc_RenderTargetSize;
    float4x4 sc_ModelMatrix;
    float4x4 sc_ModelViewProjectionMatrix;
    float4x4 sc_ModelViewProjectionMatrixInverse;
};

