#include <metal_stdlib>
#include <simd/simd.h>
#include <std2.glsl>

using namespace metal;

float2 getScreenUV(thread float4 gl_FragCoord, constant float4& sc_RenderTargetSize)
{
    return gl_FragCoord.xy * sc_RenderTargetSize.zw;
}

float4 getFramebufferColor(thread float4 gl_FragCoord, constant float4& sc_RenderTargetSize, constant texture2d<float>& sc_ScreenTexture, thread const sampler sc_ScreenTextureSmplr)
{
    return sc_ScreenTexture.sample(sc_ScreenTextureSmplr, getScreenUV(gl_FragCoord, sc_RenderTargetSize));
}

