#include <metal_stdlib>
#include <simd/simd.h>
#include <std2.glsl>

using namespace metal;

struct sc_Vertex_t
{
    float4 position;
    float3 normal;
    float3 tangent;
    float2 texture0;
    float2 texture1;
};

constant int sc_RenderingSpace [[function_constant(220)]];

constant float4 _73 = {};

sc_Vertex_t sc_LoadVertexAttributes(thread float4 position, thread float3 normal, thread float4 tangent, thread float2 texture0, thread float2 texture1)
{
    sc_Vertex_t vertex0;
    vertex0.position = position;
    vertex0.normal = normal;
    vertex0.tangent = tangent.xyz;
    vertex0.texture0 = texture0;
    vertex0.texture1 = texture1;
    return vertex0;
}

float4 sc_ObjectToScreen(thread const float4 objectPosition, constant float4x4& sc_ModelViewProjectionMatrix)
{
    #if (sc_RenderingSpace == 3)
    {
        return objectPosition;
    }
    #else // #if (sc_RenderingSpace == 3)
    {
        #if (sc_RenderingSpace == 1)
        {
            return sc_ModelViewProjectionMatrix * objectPosition;
        }
        #endif // #if (sc_RenderingSpace == 1)
    }
    #endif // #else // #if (sc_RenderingSpace == 3)
}

void sc_ProcessVertex(thread const sc_Vertex_t v, constant float4x4& sc_ModelViewProjectionMatrix, thread float3 varPos, constant float4x4& sc_ModelMatrix, thread float4 varTex01, thread float4 gl_Position)
{
    float4 param = v.position;
    float4 screenPosition = sc_ObjectToScreen(param, sc_ModelViewProjectionMatrix);
    varPos = (sc_ModelMatrix * v.position).xyz;
    varTex01 = float4(v.texture0, v.texture1);
    gl_Position = screenPosition * 1.0;
}

