//-----------------------------------------------------------------------
// Copyright (c) 2018 Snap Inc.
//-----------------------------------------------------------------------

#include <metal_stdlib>
using namespace metal;


struct Vertex
{
    float2 position [[attribute(0)]];
};

struct ColorInOut {
    float4 position [[position]];
};

struct Uniforms
{
    float4 color;
};


// vertex shader function
vertex ColorInOut vs_main(Vertex vtx [[ stage_in ]])
{
    ColorInOut out;
    out.position = float4(vtx.position, 0.0, 1.0);
    return out;
}

// fragment shader function
fragment half4 fs_main(ColorInOut in [[stage_in]],constant Uniforms& uniforms [[ buffer(1) ]])
{
    return half4(uniforms.color);
};

