//-----------------------------------------------------------------------
// Copyright (c) 2018 Snap Inc.
//-----------------------------------------------------------------------

#include <metal_stdlib>
using namespace metal;

#if defined(CMDLINE)
#include "metal_std.metal"
#else
#include <metal_std.metal>
#endif

constant bool DEBUGSHIFTS = false;

struct Vertex
{
    float4 atbCoord2d [[attribute(0)]];
};

struct ColorInOut {
    float4 position [[position]];
    half2 coord;
};

// vertex shader function
vertex ColorInOut vs_main(Vertex vtx [[ stage_in ]])
{
    ColorInOut out;

    out.coord = half2((vtx.atbCoord2d.xy * 0.5 + 0.5) + vtx.atbCoord2d.zw *0.5);
    out.position = float4(vtx.atbCoord2d.x, vtx.atbCoord2d.y, 0.0, 1.0);
    
    if( DEBUGSHIFTS )
    {
        out.coord = half2(vtx.atbCoord2d.z, vtx.atbCoord2d.w);
    }
    out.coord.y = 1.0-out.coord.y;
    return out;
}

// fragment shader function
fragment half4 fs_main(ColorInOut in [[stage_in]],
                                 texture2d<half> sc_ScreenTexture,
                                sampler sc_ScreenTextureSampler)
{
    if(DEBUGSHIFTS)
    {
        return half4(in.coord.x, in.coord.y, 0.0, 1.0);
    }

    return sc_ScreenTexture.sample(sc_ScreenTextureSampler, float2(in.coord));
};

